//-----------------------------------------------------------------------------
//  gif_crash.cpp
//
//  This programm will crash when loading the test file with an unpatched
//  Fl_GIF_Image.cxx in FLTK 1.3.4 because of too few reseved memory for the
//  color map.
//
//  The needed GIF files:
//  colormap_test.gif   - the trouble maker (no global color map)
//  ani_1.gif           - the same image with a global color map
//
//  g++ -no-pie -g gif_crash.cpp -o gif_crash $(fltk-config --use-images --ldflags --cxxflags)
//
//
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Shared_Image.H>
#include <FL/Fl_GIF_Image.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>


Fl_Box *box;
Fl_Button *button;
Fl_Shared_Image *sh_img;


void button_cb( Fl_Widget *,void *) {
    if( sh_img ) {
        sh_img->release();
        sh_img = 0;
    }
    sh_img = Fl_Shared_Image::get( "colormap_test.gif" ); // load the trouble maker
    box->image( sh_img );
    box->redraw();
}

int main() {
    const char * filename = "ani_1.gif"; // start image is ok

    fl_register_images();
    Fl_Window win(500,530);
    button = new Fl_Button( 10, 2, 150, 26, "load the bad image" );
    button->callback( button_cb );
    box = new Fl_Box(10,10,500-20,530-20);
    sh_img = Fl_Shared_Image::get( filename );
    box->image( sh_img );
    win.show();
    return(Fl::run());
}
